<?php
echo '<meta charset="utf-8" />';
if(isset($_SESSION['user_droits'])) {
	if($_SESSION['user_droits'][4]!="2")
	{
		echo '<p class="noaccess">Vous n\'avez pas accès à ce module.<br><a href="../index.php">Accueil</a></p>';
	}
	else {

		echo '<h1>Informations sur les horaires</h1>';
		echo '<h2>Fuseau horaire :</h2>';
		
		if(isset($_POST['fuseau'])) {
			$newfuseau = $_POST['bigzone'].'/'.$_POST['fuseau'];
			if($newfuseau!=$fuseau['valeur']) {
				mysqli_query($bdd,"UPDATE ".$prefix."_parametres SET valeur = '$newfuseau' WHERE param_nom = 'fuseau'");
			}
			echo '<script language="Javascript">
			<!--
			document.location.replace("param.php?page=horaires");
			// -->
			</script>';
		}
		
		echo '<p>Fuseau : <b>'.$fuseau['valeur'].'</b> - '.date("d/m/Y").' - <b>'.date("H:i").'</b>.</p>';
		$bizones = array('Africa','America','Antarctica','Arctic','Asia','Atlantic','Australia','Europe','Indian','Pacific');
		echo '<form method="POST" action="">
		<table class="noborder">
			<tr><td colspan="2">Changer de zone :</td></tr>
			<tr><td>Zone :</td><td><div class="box"><select name="bigzone" id="bigzone" onchange=\'zone()\'><option></option>';
			foreach($bizones as $bizone) {
				echo '<option';
				echo '>'.$bizone.'</option>';
			}echo '</select></div>
			</td></tr>
			<tr><td>Fuseau :</td><td><div id=\'fuseau\' style=\'display:inline\'>
				<div class="box"><select name=\'fuseau\'>
					<option value=\'-1\'></option>
				</select></div>
			</div></td></tr>
			<tr><td colspan="2" class="right"><input class="bouton boutparam" type="submit" value="Valider" name="fusvalid" /></td></tr>	
		</table></form>';
		
		echo '<h2 id="hor">Veuillez renseigner ci-dessous les horaires :</h2>
		<p class="maxwidth">Par exemple, pour le premier créneau du matin (M1) de 8h30 à 9h25, renseigner Matin - 1 - 08h30 - 9h25.</p><p class="maxwidth">Les horaires doivent être renseignés en continu, sans ruptures. Ainsi, si un créneau se termine à 9h25, le suivant doit commencer à 9h25. Les horaires qui ne respectent pas cette règle ne sont pas enregistrés.</p><p class="maxwidth">Il est conseillé de maintenir la même base horaire, globalement, dans cette page de gestion, d\'une année sur l\'autre, afin de profiter de statistiques optimales sur plusieurs années. Ainsi il est préférable de fermer un créneau dans l\'EDT plutôt que de le supprimer ici.</p><p class="maxwidth">Une fois les horaires définis, il est possible de préciser si le créneau peut accepter des inscriptions et/ou des réservations, et préciser des quotas sur l\'espace principal (par défaut, le quota 0 revient à utiliser un quota générique tel que défini dans les <a href="freq.php?page=param">paramètres du module de fréquentation</a>).</p>';
		if(isset($_POST['horaires'])) {
			$checkt = array();
			for($i=1;$i<21;$i++) {
				$deb_hor_name = $_POST['cren'.$i.'']; // M, A, P, R
				$fin_hor_name = $_POST['nb'.$i.'']; // numéro pour chaque temps
				if($deb_hor_name!='') {
					array_push($checkt,$deb_hor_name.$fin_hor_name);
				}
			}
			if(count(array_unique($checkt))<count($checkt)) {
			    echo '<p class="signal">Problème pour des créneaux qui auraient le même temps et la même position.';
			}
			else {
			   	// Création de la boucle pour inscrire ou modifier les horaires :
				for($i=1;$i<21;$i++) {
					$creneau = mysqli_query($bdd,"SELECT * FROM ".$prefix."_horaires WHERE num_creneau = '".$i."'");
					$creneau_nb = mysqli_num_rows($creneau);
					$creneau_info = mysqli_fetch_assoc($creneau);
					
					// Récupération des infos des champs :
					$deb_hor_name = $_POST['cren'.$i.'']; // M, A, P, R
					$fin_hor_name = $_POST['nb'.$i.'']; // numéro pour chaque temps
					$debut = $_POST['debut'.$i.''].':00';
					$fin = $_POST['fin'.$i.''].':00';

					if($i<20) { $debut_suiv = $_POST['debut'.($i+1).''].':00'; }
					
					// Transformation des champs pour la BDD :
					$num_creneau = $i;
					$hor_name = $deb_hor_name . $fin_hor_name;
					$crecode = array('M','A','P','R');
					$crename = array('Matin','Après-midi','Pause','Midi');
					$key = array_search($deb_hor_name,$crecode);
					$period = $crename[$key];

					echo '<p class="signal">';							
					// Gestion des insert et update pour chaque créneau :
					if($deb_hor_name==""||$fin_hor_name==""||$debut=="::00"||$fin=="::00") {
						// suppression de futurs events si le créneau est supprimé
						if(isset($creneau_info['hor_id'])) {
							$check_events = mysqli_query($bdd,"SELECT * FROM ".$prefix."_edtevent WHERE hor_id = '".$creneau_info['hor_id']."' AND week >= '".date('oW')."'");
							foreach ($check_events as $check_event) {
								mysqli_query($bdd,"DELETE FROM ".$prefix."_userevent WHERE uid = '".$check_event['uid']."'");
								mysqli_query($bdd,"DELETE FROM ".$prefix."_espaces_event WHERE uid = '".$check_event['uid']."'");
							}
							mysqli_query($bdd,"DELETE FROM ".$prefix."_edtevent WHERE hor_id = '".$creneau_info['hor_id']."'");
							// suppression du créneau
							mysqli_query($bdd,"DELETE FROM ".$prefix."_horaires WHERE num_creneau = '".$num_creneau."'");
						}
					}
					else if($debut_suiv!=":00"&&$fin!=$debut_suiv) { 
						echo 'Problème pour '.$period.' '.$fin_hor_name.' : La fin du créneau doit être le même horaire que le début du suivant.<br>';
					} 
					else if(isset($_SESSION['chev'])&&$debut!=$_SESSION['chev']) { 
						echo 'Problème pour '.$period.' '.$fin_hor_name.' : Le début du créneau doit être le même horaire que la fin du précédent.<br>';
					} // vérification de début et fin du créneau
					else if($creneau_nb==0) {
						mysqli_query($bdd,"INSERT INTO ".$prefix."_horaires (hor_id, hor_name, num_creneau, debut, fin, hor_freq, hor_resa, quota_freq, quota_resa) VALUES ('', '".$hor_name."', '".$num_creneau."', '".$debut."', '".$fin."', '001', '001', '000', '000')");
						if($deb_hor_name=="P") {
							mysqli_query($bdd,"UPDATE ".$prefix."_horaires SET hor_freq='000', hor_resa='000' WHERE num_creneau = '".$num_creneau."'");
						}
					}
					else {
						$infos_cren = mysqli_fetch_assoc(mysqli_query($bdd, "SELECT * FROM ".$prefix."_horaires WHERE num_creneau='".$num_creneau."'"));
			            $hf = $infos_cren['hor_freq'];
			            $hr = $infos_cren['hor_resa'];
			            $hqf = $infos_cren['quota_freq'];
			            $hqr = $infos_cren['quota_resa'];
						if(isset($_POST['hf'.$i.''])) { $hf = substr_replace($hf,"001",0,3); } 
						else { $hf = substr_replace($hf,"000",0,3); }
						if(isset($_POST['hr'.$i.''])) { $hr = substr_replace($hr,"001",0,3); } 
						else { $hr = substr_replace($hr,"000",0,3); }
						$hqf = substr_replace($hqf,str_pad($_POST['hqf'.$i.''],3,"0", STR_PAD_LEFT),0,3);
						$hqr = substr_replace($hqr,str_pad($_POST['hqr'.$i.''],3,"0", STR_PAD_LEFT),0,3);
									            
						mysqli_query($bdd,"UPDATE ".$prefix."_horaires SET hor_name='".$hor_name."', debut='".$debut."', fin='".$fin."', hor_freq='".$hf."', hor_resa='".$hr."', quota_freq='".$hqf."', quota_resa='".$hqr."' WHERE num_creneau = '".$num_creneau."'");
					}
					echo  '</p>';
					// Gestion des chevauchements :
					$_SESSION['chev'] = $fin;
					$_SESSION['plage'] = $hor_name;
				}
			}			
			unset($_SESSION['chev']);
			unset($_SESSION['plage']);
		}
		echo '<div style="overflow: auto;  white-space: nowrap;"><form method="POST" action="param.php?page=horaires#hor" class="padd4">
		<table id="install" class="paramform">
		<tr style="text-align:center;"><th>N°</th><th>Temps et Position</th><th>Début</th><th>Fin</th><th>Fréq.</th><th>Quota<br>Fréq.</th><th>Résa.</th><th>Quota<br>Résa.</th></tr>';
			for($i=1;$i<21;$i++) {
				$creneau = mysqli_query($bdd,"SELECT * FROM ".$prefix."_horaires WHERE num_creneau = $i");
				$creneau_nb = mysqli_num_rows($creneau);
				$creneau_info = mysqli_fetch_assoc($creneau);
				if($i<20) { 
					$suivant = mysqli_fetch_assoc(mysqli_query($bdd,"SELECT * FROM ".$prefix."_horaires WHERE num_creneau = '".($i+1)."'"));
				}
				echo '<tr>
				<td style="text-align:right;">'.$i.'</td>
				<td>
					<div class="box"><select name="cren'.$i.'"><option></option>';
					$crecode = array('M','A','P','R');
					$crename = array('Matin','Après-midi','Pause','Midi');
					for($nuchor=0;$nuchor<count($crecode);$nuchor++) {
						echo '<option value="'.$crecode[$nuchor].'"';
						if(@substr($creneau_info['hor_name'], 0, 1)==$crecode[$nuchor]) {
							echo ' selected ';
						}
						echo '>'.$crename[$nuchor].'</option>';
					}
					echo'</select></div>
					<div class="box boxh"><select name="nb'.$i.'"><option></option>';
					$cren_num = range('1','10');
					for($nuc=0;$nuc<10;$nuc++) {
						echo '<option';
						if(@substr($creneau_info['hor_name'], 1, 1)==$cren_num[$nuc]) {
							echo ' selected ';
						}
						echo '>'.$cren_num[$nuc].'</option>';
					}
					echo '</select></div>
				</td>
				<td>
					<input type="time" class="inptxt time"';
					if(isset($_SESSION['finprec'])&&isset($creneau_info['debut'])&&substr($creneau_info['debut'],0,5)!=$_SESSION['finprec']) {
						echo ' style="color:red;" ';
					}
					echo ' name="debut'.$i.'" value="'.@substr($creneau_info['debut'],0,5).'" />
				</td>
				<td>
					<input type="time" class="inptxt time" name="fin'.$i.'"';
					if(@$suivant['debut']!=""&&@substr($suivant['debut'],0,5)!=substr($creneau_info['fin'],0,5)) {
						echo ' style="color:red;" ';
					}
					echo ' value="'.@substr($creneau_info['fin'],0,5).'" />
				</td>
				<td class="horparam">';
					if($creneau_nb>0) {
						echo '<input type="checkbox" class="inptxt" name="hf'.$i.'"';
						if(substr($creneau_info['hor_freq'],0,3)=="001") { echo 'checked'; }
						echo ' />';
					}
				echo '</td>
				<td class="horparam">';
					if($creneau_nb>0) {
						echo '<input type="number" class="inptxt horparam" min="0" max="999" maxlength="3" name="hqf'.$i.'" value="'.@intval($creneau_info['quota_freq']).'" />';
					}
				echo '</td>
				<td class="horparam">';
					if($creneau_nb>0) {
						echo '<input type="checkbox" class="inptxt" name="hr'.$i.'"';
						if(substr($creneau_info['hor_resa'],0,3)=="001") { echo 'checked'; }
						echo ' />';
					}
				echo '</td>
				<td class="horparam">';
					if($creneau_nb>0) {
						echo '<input type="number" class="inptxt horparam" min="0" max="999" maxlength="3" name="hqr'.$i.'" value="'.@intval($creneau_info['quota_resa']).'" />';
					}
				echo '</td>
				</tr>';
				if(isset($creneau_info['fin'])) {
					$_SESSION['finprec'] = substr($creneau_info['fin'],0,5);
				}
			}
			if(isset($_SESSION['finprec'])) {
				unset($_SESSION['finprec']);
			}
			
			echo '<tr><td colspan="8" style="border:0;"><p class="right"><input class="bouton boutparam" type="submit" value="Valider" name="horaires" /></p></td></tr>
			
		</table>
		
		</form></div>';

		echo '<h2 id="jourscren">Gestion de la fréquentation, des réservations et des quotas par jour et par créneau</h2>';
		if(isset($_POST['activesp'])) {
			mysqli_query($bdd,"UPDATE ".$prefix."_parametres SET valeur = '1' WHERE param_nom = 'freq_gestion_jourscren'");
		}
		if(isset($_POST['desactivesp'])) {
			mysqli_query($bdd,"UPDATE ".$prefix."_parametres SET valeur = '0' WHERE param_nom = 'freq_gestion_jourscren'");			
		}
		$edtesp_param = mysqli_fetch_assoc(mysqli_query($bdd,"SELECT valeur FROM ".$prefix."_parametres WHERE param_nom = 'edt_espmulti'"));
		$verif_nivs = mysqli_query($bdd,"SELECT valeur FROM ".$prefix."_parametres WHERE param_nom = 'freq_gestion_jourscren'");
		$verif_nivs_info = mysqli_fetch_assoc($verif_nivs);
		if($verif_nivs_info['valeur']==0) {
			echo '<form action="#jourscren" name="activesp" method="POST"><p><input type="checkbox" id="activesp" name="activesp" /><label for="activesp"> Activation de la gestion par jour et par créneau</label></p><p class="paddvalid1"><input class="bouton boutparam" type="submit" value="Valider" name="activesp_valid" /></p></form>';
		}
		else if($verif_nivs_info['valeur']==1) {
			$nombre_cren = mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_horaires"));
			$dayfrommon_part1 = array_slice($tableau_day, 3, null, true); // Du lundi au jeudi
			$dayfrommon_part2 = array_slice($tableau_day, 0, 3, true);   // Du vendredi au dimanche
			$dayfrommon = $dayfrommon_part1 + $dayfrommon_part2;
			if(isset($_POST['quotasj'])) {
				// Création de la boucle pour inscrire ou modifier les horaires :
				for($i=1;$i<=$nombre_cren;$i++) {					
					$num_creneau = $i;
					$ex = mysqli_fetch_assoc(mysqli_query($bdd, "SELECT * FROM ".$prefix."_horaires WHERE num_creneau = '".$num_creneau."'"));
			        $hf_exist = substr($ex['hor_freq'],0,3);
			        $hqf_exist = substr($ex['quota_freq'],0,3);
			        $hr_exist = substr($ex['hor_resa'],0,3);
			        $hqr_exist = substr($ex['quota_resa'],0,3);

			        foreach ($dayfrommon as $stkey => $stvalue){ 
						if(isset($_POST['hf_'.$stkey.'_'.$i])) { $hf_exist .= $stkey."001"; } 
						else { $hf_exist .= $stkey."000"; }
						if(isset($_POST['hr_'.$stkey.'_'.$i])) { $hr_exist .= $stkey."001"; } 
						else { $hr_exist .= $stkey."000"; }		
						$hqf_exist .= $stkey.str_pad($_POST['hqf_'.$stkey.'_'.$i.''],3,"0", STR_PAD_LEFT);
						$hqr_exist .= $stkey.str_pad($_POST['hqr_'.$stkey.'_'.$i.''],3,"0", STR_PAD_LEFT);
					}
					mysqli_query($bdd,"UPDATE ".$prefix."_horaires SET hor_freq='".$hf_exist."', hor_resa='".$hr_exist."', quota_freq='".$hqf_exist."', quota_resa='".$hqr_exist."' WHERE num_creneau = '".$num_creneau."'");
				}	
			}

			echo '<div style="overflow: auto;  white-space: nowrap;"><form method="POST" action="param.php?page=horaires" class="padd4">
			<table id="install" class="paramform">
			<tr style="text-align:center;"><th rowspan="2">Créneau</th>';
			foreach ($dayfrommon as $stkey => $stvalue){ 
				echo '<th colspan="4">'. $stvalue.'</th>'; 
			}
			echo '</tr>';
			echo '<tr>';
			for ($i = 0; $i < count($tableau_day); $i++) {
			   echo '<th>Fréq.</th><th>Quota<br>Fréq.</th><th>Résa.</th><th>Quota<br>Résa.</th>';
			    
			}
			echo '</tr>';
				for($i=1;$i<=$nombre_cren;$i++) {
					$creneau = mysqli_query($bdd,"SELECT * FROM ".$prefix."_horaires WHERE num_creneau = $i");
					$creneau_nb = mysqli_num_rows($creneau);
					$creneau_info = mysqli_fetch_assoc($creneau);
					if($i<20) { 
						$suivant = mysqli_fetch_assoc(mysqli_query($bdd,"SELECT * FROM ".$prefix."_horaires WHERE num_creneau = '".($i+1)."'"));
					}
					echo '<tr>
					<td style="text-align:right;"><b>'.@substr($creneau_info['hor_name'], 0, 1).@substr($creneau_info['hor_name'], 1, 1).'</b> '.@substr($creneau_info['debut'],0,5).' - '.@substr($creneau_info['fin'],0,5).'</td>';
					
					foreach ($dayfrommon as $cle => $jour) {
						echo '<td class="horparam">';
							
					if($creneau_nb>0) {
							echo '<input type="checkbox" class="inptxt" name="hf_'.$cle.'_'.$i.'"';
							if(substr($creneau_info['hor_freq'], strpos($creneau_info['hor_freq'], $cle) + strlen($cle), 3)=="001") { echo ' checked'; }
							echo ' />';
						}
						echo '</td>
						<td class="horparam">';
							if($creneau_nb>0) {
								echo '<input type="number" class="inptxt horparam" min="0" max="999" maxlength="3" name="hqf_'.$cle.'_'.$i.'" value="'.@intval(substr($creneau_info['quota_freq'], strpos($creneau_info['quota_freq'], $cle) + strlen($cle), 3)).'" />';
							}							
						echo '</td>
						<td class="horparam">';
							if($creneau_nb>0) {
								echo '<input type="checkbox" class="inptxt" name="hr_'.$cle.'_'.$i.'"';
								if(substr($creneau_info['hor_resa'], strpos($creneau_info['hor_resa'], $cle) + strlen($cle), 3)=="001") { echo ' checked'; }
								echo ' />';
							}
						echo '</td>
						<td class="horparam">';
							if($creneau_nb>0) {
								echo '<input type="number" class="inptxt horparam" min="0" max="999" maxlength="3" name="hqr_'.$cle.'_'.$i.'" value="'.@intval(substr($creneau_info['quota_resa'], strpos($creneau_info['quota_resa'], $cle) + strlen($cle), 3)).'" />';
							}
						echo '</td>';
					}
					echo '</tr>';
				}
			echo '<tr><td colspan="8" style="border:0;"><p class="right"><input class="bouton boutparam" type="submit" value="Valider" name="quotasj" /></p></td></tr>
				
			</table>
			
			</form>';			

			echo '</div>';		

			echo '<p><b>Désactivation de cette option :</b></p>';
			echo '<form action="#jourscren" name="desactivesp" method="POST"><p><input type="checkbox" id="desactivesp" name="desactivesp" /><label for="desactivesp"> Désactivation de la gestion par jour et par créneau</label></p><span class="paddvalid1 right"><input class="bouton boutparam" type="submit" value="Valider" name="desactivesp_valid" /></span></p></form>';
			}	
		}
	}
else {
	include('include/noaccess.php');
	echo '<br><a href="../index.php">Accueil</a></p>';
}
?>